/*
This file is auto-generated by OWL2Go (https://git.rwth-aachen.de/acs/public/ontology/owl/owl2go).

Copyright 2020 Institute for Automation of Complex Power Systems,
E.ON Energy Research Center, RWTH Aachen University

This project is licensed under either of
- Apache License, Version 2.0
- MIT License
at your option.

Apache License, Version 2.0:

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.

MIT License:

Permission is hereby granted, free of charge, to any person obtaining a copy
of this software and associated documentation files (the "Software"), to deal
in the Software without restriction, including without limitation the rights
to use, copy, modify, merge, publish, distribute, sublicense, and/or sell
copies of the Software, and to permit persons to whom the Software is
furnished to do so, subject to the following conditions:

The above copyright notice and this permission notice shall be included in
all copies or substantial portions of the Software.

THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR
IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY,
FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE
AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER
LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM,
OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN
THE SOFTWARE.
*/

package ontology

import (
	"errors"
	"git.rwth-aachen.de/acs/public/ontology/owl/owl2go/pkg/rdf"
	"git.rwth-aachen.de/acs/public/ontology/owl/owl2go/pkg/owl"
	"strings"
)

// SarefProfile A specification associated to a device to collect information about a certain Property (e.g., Energy) or Commodity (e.g.Water) for optimizing its usage in the home, office or building in which the device is located. This specification is about a certain Property or Commodity (saref:isAbout), can be calculated over a time span (saref:hasTime ) and can be associated to some costs (saref:hasPrice). An example is the Power Profile defined in the SAREF4ENER extension that can be associated to a device for optimizing the Energy efficiency in the home, office or building in which the device is located.
type SarefProfile interface {
	owl.Thing
	sarefConsistsOfMultipleSarefProfile
	sarefHasPriceMultipleSarefPrice
	sarefHasTimeMultipleSarefTime
	sarefIsAboutMultipleThing
	IsSarefProfile() bool // indicates base class
}

// sSarefProfile A specification associated to a device to collect information about a certain Property (e.g., Energy) or Commodity (e.g.Water) for optimizing its usage in the home, office or building in which the device is located. This specification is about a certain Property or Commodity (saref:isAbout), can be calculated over a time span (saref:hasTime ) and can be associated to some costs (saref:hasPrice). An example is the Power Profile defined in the SAREF4ENER extension that can be associated to a device for optimizing the Energy efficiency in the home, office or building in which the device is located.
type sSarefProfile struct {
	propCommon
	propSarefConsistsOfBaseSarefProfileTypeSarefProfileMultipleSarefProfile
	propSarefHasPriceBaseSarefPriceTypeSarefPriceMultipleSarefPrice
	propSarefHasTimeBaseSarefTimeTypeSarefTimeMultipleSarefTime
	propSarefIsAboutBaseThingTypeThingMultipleSarefCommoditySarefProperty
}

// NewSarefProfile creates a new SarefProfile
func (mod *Model) NewSarefProfile(iri string) (ret SarefProfile, err error) {
	if mod.Exist(iri) {
		err = errors.New("Resource already exists")
		return
	}
	res := &sSarefProfile{}
	pc := propCommon{iri: iri, typ: "SarefProfile", model: mod}
	res.propCommon = pc
	mod.addSarefProfile(res)
	res.makeMaps()
	ret = res
	return
}

// makeMaps creates initiliazes maps
func (res *sSarefProfile) makeMaps() {
	res.sarefConsistsOf = make(map[string]SarefProfile)
	res.sarefHasPrice = make(map[string]SarefPrice)
	res.sarefHasTime = make(map[string]SarefTime)
	res.sarefIsAbout = make(map[string]owl.Thing)
	return
}

// addSarefProfile adds SarefProfile to model
func (mod *Model) addSarefProfile(res SarefProfile) {
	mod.mSarefProfile[res.IRI()] = res
	mod.mThing[res.IRI()] = res
	return
}

// SarefProfile returns all resources with given prefix
func (mod *Model) SarefProfile(prefix string) (res []SarefProfile) {
	for i := range mod.mSarefProfile {
		if strings.HasPrefix(i, prefix) {
			res = append(res, mod.mSarefProfile[i])
		}
	}
	return
}

// RemoveObject deletes all its references in this object
func (res *sSarefProfile) RemoveObject(obj owl.Thing, prop string) {
	switch prop {
	case "https://w3id.org/saref#consistsOf":
		res.propSarefConsistsOfBaseSarefProfileTypeSarefProfileMultipleSarefProfile.removeObject(obj)
	case "https://w3id.org/saref#hasPrice":
		res.propSarefHasPriceBaseSarefPriceTypeSarefPriceMultipleSarefPrice.removeObject(obj)
	case "https://w3id.org/saref#hasTime":
		res.propSarefHasTimeBaseSarefTimeTypeSarefTimeMultipleSarefTime.removeObject(obj)
	case "https://w3id.org/saref#isAbout":
		res.propSarefIsAboutBaseThingTypeThingMultipleSarefCommoditySarefProperty.removeObject(obj)
	default:
	}
	return
}

// isSarefProfile indicates base class
func (res *sSarefProfile) IsSarefProfile() bool {
	return true
}

// InitFromNode initializes the resource from a graph node
func (res *sSarefProfile) InitFromNode(node *rdf.Node) (err error) {
	for i := range node.Edge {
		res.propsInit(node.Edge[i])
	}
	return
}

// propsInit initializes the property from a graph node
func (res *sSarefProfile) propsInit(pred *rdf.Edge) (err error) {
	switch pred.Pred.String() {
	case "https://w3id.org/saref#consistsOf":
		res.propSarefConsistsOfBaseSarefProfileTypeSarefProfileMultipleSarefProfile.init(res.model, pred.Object.Term.String())
	case "https://w3id.org/saref#hasPrice":
		res.propSarefHasPriceBaseSarefPriceTypeSarefPriceMultipleSarefPrice.init(res.model, pred.Object.Term.String())
	case "https://w3id.org/saref#hasTime":
		res.propSarefHasTimeBaseSarefTimeTypeSarefTimeMultipleSarefTime.init(res.model, pred.Object.Term.String())
	case "https://w3id.org/saref#isAbout":
		res.propSarefIsAboutBaseThingTypeThingMultipleSarefCommoditySarefProperty.init(res.model, pred.Object.Term.String())
	default:
	}
	return
}

// ToGraph creates a new owl graph node and adds it to the graph
func (res *sSarefProfile) ToGraph(g *rdf.Graph) {
	node := owl.AddObjectToGraph(g, "https://w3id.org/saref#Profile", res)
	res.propsToGraph(node, g)
	return
}

// propsToGraph adds all properties to the graph
func (res *sSarefProfile) propsToGraph(node *rdf.Node, g *rdf.Graph) {
	res.propSarefConsistsOfBaseSarefProfileTypeSarefProfileMultipleSarefProfile.toGraph(node, g)
	res.propSarefHasPriceBaseSarefPriceTypeSarefPriceMultipleSarefPrice.toGraph(node, g)
	res.propSarefHasTimeBaseSarefTimeTypeSarefTimeMultipleSarefTime.toGraph(node, g)
	res.propSarefIsAboutBaseThingTypeThingMultipleSarefCommoditySarefProperty.toGraph(node, g)
	return
}

// String prints the object into a string
func (res *sSarefProfile) String() (ret string) {
	ret = res.iri + " " + "SarefProfile\n"
	ret += res.propsString()
	return
}

// propsString prints the object into a string
func (res *sSarefProfile) propsString() (ret string) {
	ret = ""
	ret += res.propSarefConsistsOfBaseSarefProfileTypeSarefProfileMultipleSarefProfile.String()
	ret += res.propSarefHasPriceBaseSarefPriceTypeSarefPriceMultipleSarefPrice.String()
	ret += res.propSarefHasTimeBaseSarefTimeTypeSarefTimeMultipleSarefTime.String()
	ret += res.propSarefIsAboutBaseThingTypeThingMultipleSarefCommoditySarefProperty.String()
	return
}


